#ifndef GUI_H
#define GUI_H

#ifdef __cplusplus
extern "C"
{
	#include "misc.h"
	#include "wificonnect.h"
	#include "background.c"
}
#include "woopsi.h"
#include "woopsiheaders.h"

#include <string>
using namespace std;

using namespace WoopsiUI;


class gui : public Woopsi, public EventHandler {
public:
	void startup();
	void shutdown();
	//Accepts a fileinfo** and propogates the provided ScrollingListbox with the information
	//from the given fileinfo**
	void getFileListing(fileinfo**, ScrollingListBox*);
	bool handleEvent(const EventArgs& e);
	void setProgress(int);

private:
	void connectFocusChange();
	void localCdUp();
	char* deleteBack( char * );
	ProgressBar* progress;
	AmigaScreen* connectScreen;
	AmigaScreen* fileScreen;
	AmigaScreen* keyScreen;
	AmigaScreen* transferScreen;
	ScrollingListBox* remoteFiles;
	ScrollingListBox* localFiles;
	Button* download;
	Button* upload;
	Button* connect;
	Button* disconnect;
	Button* remoteCdup;
	Button* localDirUp;
	TextBox* serverText;
	TextBox* loginText;
	TextBox* passwordText;
	TextBox* curRemoteText;
	TextBox* curLocalText;
	Label* fileLbl;
	Label* transferLbl;
	Label* ofLbl;
	Label* pwLbl;
	Label* loginLbl;
	Label* serverConnect;
	Label* local;
	Label* remote;
	Label* curRemoteDirLbl;
	Label* curLocalDirLbl;
	WoopsiKeyboard* keyboard;
	const WoopsiKey* key;
	//Focus values 1 = serverText, 2 = loginText, 3 = passwordText
	int connectFocus;
	Alert* popup;
	fileinfo** localDir;
	fileinfo** remoteDir;
	char* curLocal;
	char* curRemote;
};
#else
typedef struct gui gui;
#endif
#ifdef __cplusplus
extern "C" {
#endif
#if defined(__STDC__) || defined (__cplusplus)
extern void callSetProgress( int );
extern void callSetProgressWrapper(int);
#else
extern void callSetProgress();
extern void callSetProgressWrapper();
#endif
#ifdef __cplusplus
}
#endif

#endif /*GUI_H*/
	